program s0term;

  (*$I s0term.doc *)

  uses crt,dos,util,capi;

  const max_data=7;
        max_plci=2;
        max_ncci=2;
        max_screen=9;                  (* seiten 0..pred(max_screen)       *)

  type data_bereich=0..max_data;
       plci_bereich=0..max_plci;
       ncci_bereich=0..max_ncci;
       screen_bereich=0..max_screen;

       t_data      = array[data_bereich] of string;
       t_slots     = set of data_bereich;
       t_par       = array[1..127] of byte;       (* x29-parameter         *)

       t_ncci=record
                ncci_status : byte;           (* status: beschreibung s.u. *)
                ncci_word   : word;           (* eigentlicher ncci         *)
                ncci_valid  : boolean;        (* einfacher als status      *)
                ncci_slots  : t_slots;        (* slots fr die daten       *)
                ncci_data1  : string;         (* sammelpuffer              *)
                ncci_data2  : t_data;         (* sendepuffer               *)
                ncci_screen : screen_bereich; (* bildschirmnummer          *)
                ncci_x29    : boolean;        (* ob hier x.29 gemacht wird *)
                ncci_par    : t_par;          (* x.29-parameter            *)
                ncci_down   : boolean;        (* wenn ein download luft   *)
                ncci_down_fn: string[12];     (* der download-filename     *)
                ncci_down_ti: string[8];      (* start-uhrzeit             *)
                ncci_down_f : word;           (* handle fr download       *)
                ncci_down_s : longint;        (* soll-lnge des down-files *)
                ncci_down_i : longint;        (* ist-lnge des down-files  *)
                ncci_log    : boolean;        (* alles ankommende speichern*)
                ncci_log_f  : text;           (* textfile fr log          *)
                ncci_up     : boolean;        (* wenn ein upload luft     *)
                ncci_up_f   : word            (* handle fr upload         *)
              end; (* t_ncci *)
       t_nccis=array[ncci_bereich] of t_ncci; (* alle nccis eines plcis    *)

       t_plci=record
                plci_incoming : word;         (* incoming call msgno       *)
                plci_status   : byte;         (* status: beschreibung s.u. *)
                plci_word     : word;         (* eigentlicher plci         *)
                plci_valid    : boolean;      (* einfacher als status      *)
                plci_nccis    : t_nccis       (* die zugehrigen nccis     *)
              end; (* t_plci *)
       t_plcis=array[plci_bereich] of t_plci; (* alle plcis                *)

       p_plcis=^t_plcis;

       t_character=record
                     char_char   : char;
                     char_attrib : byte
                   end; (* t_character *)

       t_video=array[0..24,0..79] of t_character;

       t_screen=record
                  screen_video      : t_video;      (* zeichen / attribute *)
                  screen_row        : 0..24;        (* cursor row          *)
                  screen_column     : 0..79;        (* cursor column       *)
                  screen_plci_index : plci_bereich; (* plci-index          *)
                  screen_ncci_index : ncci_bereich  (* ncci-index          *)
                end; (* t_screen *)
       t_screens=array[screen_bereich] of t_screen; (* alle bildschirme    *)

  var error,len:word;
      temp:string;
      lt:byte absolute temp;
      cp:capi_pointer;
      abfragen,clr,connect_pending,ende,listen_pending,x29_global:boolean;
      block:capi_body;
      c:char;
      b2,b3,cb:byte;
      plcis:p_plcis;          (* hier werden alle session-daten gemerkt *)
      active:screen_bereich;  (* aktives fenster (index fr "sessions") *)
      screens:t_screens;      (* bildschirm-zwischenspeicher            *)
      screen:^t_video;        (* physikalischer bildschirm              *)
      i,code:integer;
      f_upload:file of byte;
      regs:dos.registers;
      date,time:string[8];

  function dos_version:byte;
    var regs:dos.registers;
    begin (* dos_version *)
      regs.ax:=$3000;
      msdos(regs);
      dos_version:=regs.al
    end; (* dos_version *)

  procedure init_par(var par:t_par);
    (* die parameter fr x.29 werden derzeit lediglich komplett  *)
    (* initialisiert, aber (noch?) nicht komplett ausgewertet.   *)
    begin (* init_par *)
      fillchar(par,sizeof(par),0); (* alles undefinierte lschen *)

      (* --- INTERNATIONALE PARAMETER --- *)

      par[1]:=1;           (* ctrl-p ist austrittsstzeuerzeichen *)
      par[2]:=1;           (* lokales echo ist eingeschaltet     *)
      par[3]:=2;           (* weiterleiten bei RETURN            *)
      par[4]:=0;           (* keine weiterleitungs-zeitstufe     *)
      par[5]:=2;           (* xon/xoff incoming                  *)
      par[6]:=1;           (* ausgabe von pad-meldungen ein      *)
      par[7]:=21;          (* break-behandlung                   *)
      par[8]:=0;           (* ausgaben nicht verwerfen           *)
      par[9]:=0;           (* keine nullbytes                    *)
      par[10]:=0;          (* kein zeilenumbruch                 *)
      par[11]:=100;        (* geschwindigkeit (nicht definiert)  *)
      par[12]:=1;          (* xon/xoff outgoing                  *)
      par[13]:=4;          (* zeilenvorschubzeichen              *)
      par[14]:=0;          (* keine fllzeichen                  *)
      par[15]:=1;          (* lokales editieren ein              *)
      par[16]:=8;          (* lschen von zeichen mit backspace  *)
      par[17]:=0;          (* kein lokales lschen von zeilen    *)
      par[18]:=20;         (* wiedergabe von zeilen              *)
      par[19]:=2;          (* editier-pad-meldungen fr pc       *)
      par[20]:=0;          (* keine echo-maske                   *)
      par[21]:=0;          (* keine paritt                      *)
      par[22]:=0;          (* keine seite abwarten               *)

      (* --- NATIONALE PARAMETER --- *)

      par[118]:=par[16];   (* lschen von zeichen                *)
      par[119]:=par[17];   (* lschen von zeilen                 *)
      par[120]:=par[18];   (* wiedergabe von zeilen              *)
      par[121]:=3;         (* 1. weiterleitungszeichen = ctrl-c  *)
      par[122]:=24;        (* 2. weiterleitungszeichen = ctrl-x  *)
      par[123]:=par[21];   (* paritt                            *)
      par[125]:=30;        (* sekunden warten whrend eingabe    *)
      par[126]:=par[13]    (* zeilenvorschubzeichen              *)
    end; (* init_par *)

  procedure get_plci_index(plci:word;var plci_index:plci_bereich);
    var i:plci_bereich;
        found:boolean;
    begin (* get_plci_index *)
      i:=0;
      found:=false;
      repeat
        inc(i);
        with plcis^[i] do
          found:=(plci=plci_word) and plci_valid
      until found or (i=max_plci);
      if found then
        plci_index:=i
      else (* also: not found *)
        plci_index:=0
    end; (* get_plci_index *)

  procedure get_ncci_index(ncci:word;var plci_index:plci_bereich;var ncci_index:ncci_bereich);
    var i:plci_bereich;
        j:ncci_bereich;
        found:boolean;
    begin (* get_ncci_index *)
      i:=0;
      found:=false;
      repeat
        inc(i);
        with plcis^[i] do begin
          if plci_valid then begin (* plci ist schon mal valid *)
            j:=0;
            repeat
              inc(j);
              with plci_nccis[j] do
                found:=(ncci=ncci_word) and ncci_valid
            until found or (j=max_ncci)
          end (* if plci_valid: plci ist schon mal valid *)
        end (* with plcis^[i] *)
      until found or (i=max_plci);
      if found then begin
        plci_index:=i;
        ncci_index:=j
      end else begin (* also: not found *)
        plci_index:=0;
        ncci_index:=0
      end (* not found *)
    end; (* get_ncci_index *)

  procedure active_screen(nr:screen_bereich);
    begin (* active_screen *)
      if nr<>active then begin (* anderer *)
        with screens[active] do begin
          screen_video:=screen^;
          screen_row:=pred(wherey);
          screen_column:=pred(wherex)
        end; (* with screens[active] *)
        with screens[nr] do begin
          screen^:=screen_video;
          gotoxy(succ(screen_column),succ(screen_row))
        end; (* with screens[nr] *)
        active:=nr
      end (* if nr<>active: anderer *)
    end; (* active_screen *)

  procedure write_screen(nr:screen_bereich;s:string);
    var ls:byte absolute s;
        p:byte;

    procedure scroll(nr:screen_bereich);
      var i:0..23;
          j:0..79;
      begin (* scroll *)
        for i:=0 to 23 do begin
          for j:=0 to 79 do begin
            with screens[nr] do
              screen_video[i,j]:=screen_video[succ(i),j]
          end (* for j:=0 to 79 *)
        end; (* for i:=0 to 23 *)
        for j:=0 to 79 do (* unterste zeile leermachen *)
          screens[nr].screen_video[24,j].char_char:=' '
      end; (* scroll *)

    begin (* write_screen *)
      if nr=active then (* aktiver schirm *)
        write(s)
      else begin (* also: nr<>active: inaktiver schirm *)
        with screens[nr] do begin
          for p:=1 to ls do begin
            case s[p] of
              ^G:write(^G);
              ^H:begin (* bs *)
                   if screen_column>0 then
                     dec(screen_column)
                   else begin (* also: screen_column(<)=0 *)
                     if screen_row>0 then begin
                       screen_column:=79;
                       dec(screen_row)
                     end (* if screen_row>0 *)
                   end (* screen_column(<)=0 *)
                 end; (* bs *)
              ^M:screen_column:=0;
              ^J:begin (* lf *)
                   if screen_row<24 then
                     inc(screen_row)
                   else (* also: screen_row(>)=24 *)
                     scroll(nr)
                 end (* lf *)
            else (* case s[p] *)
              screen_video[screen_row,screen_column].char_char:=s[p];
              if screen_column<79 then
                inc(screen_column)
              else begin (* also: screen_column(>)=79 *)
                screen_column:=0;
                if screen_row<24 then
                  inc(screen_row)
                else (* also: screen_row(>)=24 *)
                  scroll(nr)
              end (* screen_column(>)=79 *)
            end (* case s[p] *)
          end (* for p:=1 to ls *)
        end (* with screens[nr] *)
      end (* nr<>active: inaktiver schirm *)
    end; (* write_screen *)

  procedure writeln_screen(nr:screen_bereich;s:string);
    var ls:byte absolute s;
    begin (* writeln_screen *)
      if ls<=253 then (* pat noch in einen string mit CRLF *)
        write_screen(nr,s+^M^J)
      else begin (* also: ls>253: pat nicht mehr in einen string mit CRLF *)
        write_screen(nr,s);
        write_screen(nr,^M^J)
      end (* ls>253: pat nicht mehr in einen string mit CRLF *)
    end; (* writeln_screen *)

  function next_free_plci_index:plci_bereich;
    var plci_index:plci_bereich;
    begin (* next_free_plci_index *)
      plci_index:=0;
      repeat
        inc(plci_index)
      until (plci_index=max_plci) or (not plcis^[plci_index].plci_valid);
      with plcis^[plci_index] do begin
        if plci_valid then (* auch noch valid: nichts mehr frei *)
          next_free_plci_index:=0
        else (* also: not plci_valid: aktueller index frei *)
          next_free_plci_index:=plci_index
      end (* with plcis^[plci_index] *)
    end; (* next_free_plci_index *)

  function next_free_ncci_index(plci_index:plci_bereich):ncci_bereich;
    var ncci_index:ncci_bereich;
    begin (* next_free_ncci_index *)
      ncci_index:=0;
      with plcis^[plci_index] do begin
        repeat
          inc(ncci_index)
        until (ncci_index=max_ncci) or (not plci_nccis[ncci_index].ncci_valid);
        with plci_nccis[ncci_index] do begin
          if ncci_valid then (* auch noch valid: nichts mehr frei *)
            next_free_ncci_index:=0
          else (* also: not ncci_valid: aktueller index frei *)
            next_free_ncci_index:=ncci_index
        end (* with plci_nccis[ncci_index] *)
      end (* with plcis^[plci_index] *)
    end; (* next_free_ncci_index *)

  function next_free_screen_index:screen_bereich;
    var screen_index:screen_bereich;

    function screen_empty(nr:screen_bereich):boolean;
      begin (* screen_empty *)
        with screens[nr] do
          screen_empty:=(screen_plci_index=0) and (screen_ncci_index=0)
      end; (* screen_empty *)

    begin (* next_free_screen_index *)
      screen_index:=0;
      repeat
        inc(screen_index)
      until (screen_index=max_screen) or screen_empty(screen_index);
      if screen_empty(screen_index) then (* freien bildschirm gefunden *)
        next_free_screen_index:=screen_index
      else (* also: not screen_empty(screen_index): alles voll *)
        next_free_screen_index:=0
    end; (* next_free_screen_index *)

  procedure verarbeite_message(cp:capi_pointer);

    (* --- CONF --- *)

    procedure verarbeite_message_conf(cp:capi_pointer);
      var plci_index:plci_bereich;
          ncci_index:ncci_bereich;
          hs:string[8]; (* nur fr zahlen *)
      begin (* verarbeite_message_conf *)
        case cp^.h.command of

          (* --- CONNECT_CONF --- *)

          capi_connect:begin (* capi_connect *)
            with cp^.b do begin
              writeln_screen(0,'CONNECT_CONF...'+capi_error(capi_connect_conf_info));
              if capi_connect_conf_info=0 then begin (* conf ok *)
                plci_index:=next_free_plci_index;
                if plci_index=0 then (* eigentlich nie *)
                  writeln_screen(0,'CONNECT_CONF: Kein freier PLCI-Index!')
                else begin (* also: plci_index(<)>0 *)
                  with plcis^[plci_index] do begin
                    plci_word:=capi_connect_conf_plci;
                    plci_valid:=true; (* valid *)
                    plci_status:=2 (* warten auf connect_active_ind *)
                  end (* with plcis^[plci_index] *)
                end (* plci_index(<)>0 *)
              end (* if capi_connect_conf_info=0: conf ok *)
            end; (* with cp^.b *)
            connect_pending:=false
          end; (* capi_connect *)

          (* --- DISCONNECT_CONF --- *)

          capi_disconnect:begin (* capi_disconnect *)
            writeln_screen(0,'DISCONNECT_CONF...'+capi_error(cp^.b.capi_disconnect_conf_info));
            if cp^.b.capi_disconnect_conf_info=0 then begin (* conf ok *)
              get_plci_index(cp^.b.capi_disconnect_conf_plci,plci_index);
              if plci_index>0 then (* gefunden *)
                plcis^[plci_index].plci_status:=22 (* warten auf disconnect_ind *)
              else (* also: plci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_disconnect_conf_plci,false)+'H nicht gefunden')
            end (* if cp^.b.capi_disconnect_conf_info=0: conf ok *)
          end; (* capi_disconnect *)

          (* --- LISTEN_CONF --- *)

          capi_listen:begin (* capi_listen *)
            writeln_screen(0,'LISTEN_CONF...'+capi_error(cp^.b.capi_listen_conf_info));
            listen_pending:=false
          end; (* capi_listen *)

          (* --- INFO_CONF --- *)

          capi_info:begin (* capi_info *)
            writeln_screen(0,'INFO_CONF...'+capi_error(cp^.b.capi_info_conf_info))
          end; (* capi_info *)

          (* --- SELECT_B2_PROTOCOL_CONF --- *)

          capi_select_b2_protocol:begin (* capi_select_b2_protocol *)
            writeln_screen(0,'SELECT_B2_PROTOCOL_CONF...'+capi_error(cp^.b.capi_select_b2_protocol_conf_info));
            if cp^.b.capi_select_b2_protocol_conf_info=0 then begin (* kein fehler *)
              get_plci_index(cp^.b.capi_select_b2_protocol_conf_plci,plci_index);
              if plci_index>0 then begin (* gefunden *)
                with plcis^[plci_index] do begin
                  case plci_status of
                     3:begin (* 3: abgehender ruf *)
                         with block do begin
                           capi_select_b3_protocol_req_plci:=plci_word;
                           capi_select_b3_protocol_req_b3_protocol:=b3;
                           capi_select_b3_protocol_req_ncpd.length:=0
                         end; (* with block *)
                         error:=capi_send_req(capi_select_b3_protocol,block,4);
                         writeln_screen(0,'API_PUT_MESSAGE (SELECT_B3_PROTOCOL)...'+capi_error(error));
                         plci_status:=4 (* warten auf select_b3_protocol_conf *)
                       end; (* 3: abgehender ruf *)
                    11:begin (* 11: ankommender ruf *)
                         with block do begin
                           capi_select_b3_protocol_req_plci:=plci_word;
                           capi_select_b3_protocol_req_b3_protocol:=b3;
                           capi_select_b3_protocol_req_ncpd.length:=0
                         end; (* with block *)
                         error:=capi_send_req(capi_select_b3_protocol,block,4);
                         writeln_screen(0,'API_PUT_MESSAGE (SELECT_B3_PROTOCOL)...'+capi_error(error));
                         plci_status:=12 (* warten auf select_b3_protocol_conf *)
                       end (* 11: ankommender ruf *)
                  else (* case plci_status *)
                    str(plci_status,hs);
                    writeln_screen(0,'Unbekannter PLCI-Status Nr. '+hs+'!')
                  end (* case plci_status *)
                end (* with plcis^[plci_index] *)
              end else (* also: plci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_select_b2_protocol_conf_plci,false)+'H nicht gefunden')
            end (* if cp^.b.capi_select_b2_protocol_conf_info=0: kein fehler *)
          end; (* capi_select_b2_protocol *)

          (* --- SELECT_B3_PROTOCOL_CONF --- *)

          capi_select_b3_protocol:begin (* capi_select_b3_protocol *)
            writeln_screen(0,'SELECT_B3_PROTOCOL_CONF...'+capi_error(cp^.b.capi_select_b3_protocol_conf_info));
            if cp^.b.capi_select_b3_protocol_conf_info=0 then begin (* kein fehler *)
              get_plci_index(cp^.b.capi_select_b3_protocol_conf_plci,plci_index);
              if plci_index>0 then begin (* gefunden *)
                with plcis^[plci_index] do begin
                  case plci_status of
                     4:begin (* 4: abgehender ruf *)
                         plci_status:=100; (* plci betriebsbereit *)
                         with block do begin
                           capi_connect_b3_req_plci:=plci_word;
                           capi_connect_b3_req_ncpi:='' (* lnge 0 *)
                         end; (* with block *)
                         error:=capi_send_req(capi_connect_b3,block,3);
                         writeln_screen(0,'API_PUT_MESSAGE (CONNECT_B3_REQ)...'+capi_error(error))
                       end; (* 4: abgehender ruf *)
                    12:begin (* 12: ankommender ruf *)
                         block.capi_listen_b3_req_plci:=cp^.b.capi_connect_ind_plci;
                         error:=capi_send_req(capi_listen_b3,block,2);
                         writeln_screen(0,'API_PUT_MESSAGE (LISTEN_B3_REQ)...'+capi_error(error));
                         plci_status:=13 (* warten auf listen_b3_conf *)
                       end (* 12: ankommender ruf *)
                  else (* case plci_status *)
                    str(plci_status,hs);
                    writeln_screen(0,'Unbekannter PLCI-Status Nr. '+hs+'!')
                  end (* case plci_status *)
                end (* with plcis^[plci_index] *)
              end else (* also: plci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_select_b3_protocol_conf_plci,false)+'H nicht gefunden')
            end (* if cp^.b.capi_select_b3_protocol_conf_info=0: kein fehler *)
          end; (* capi_select_b3_protocol *)

          (* --- LISTEN_B3_CONF --- *)

          capi_listen_b3:begin (* capi_listen_b3 *)
            writeln_screen(0,'LISTEN_B3_CONF...'+capi_error(cp^.b.capi_listen_b3_conf_info));
            if cp^.b.capi_listen_b3_conf_info=0 then begin (* kein fehler *)
              get_plci_index(cp^.b.capi_listen_b3_conf_plci,plci_index);
              if plci_index>0 then begin (* gefunden *)
                with plcis^[plci_index] do begin
                  case plci_status of
                    100:begin (* 100: schon betriebsbereit, abgehend *)
                          with block do begin
                            capi_connect_b3_req_plci:=plci_word;
                            capi_connect_b3_req_ncpi:='' (* lnge 0 *)
                          end; (* with block *)
                          error:=capi_send_req(capi_connect_b3,block,3);
                          writeln_screen(0,'API_PUT_MESSAGE (CONNECT_B3_REQ)...'+capi_error(error))
                        end; (* 100: schon betriebsbereit, abgehend *)
                     13:begin (* 13: ankommende verbindung *)
                          with block do begin
                            capi_connect_resp_plci:=plci_word;
                            capi_connect_resp_reject:=0
                          end; (* with block *)
                          error:=capi_send_resp(capi_connect,block,3,plci_incoming);
                          writeln_screen(0,'API_PUT_MESSAGE (CONNECT_RESP)...'+capi_error(error));
                          plci_status:=14 (* warten auf connect_active_ind *)
                        end (* 13: ankommende verbindung *)
                  else (* case plci_status *)
                    str(plci_status,hs);
                    writeln_screen(0,'Unbekannter PLCI-Status Nr. '+hs+'!')
                  end (* case plci_status *)
                end (* with plcis^[plci_index] *)
              end else (* also: plci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_listen_b3_conf_plci,false)+'H nicht gefunden')
            end (* if cp^.b.capi_listen_b3_conf_info=0: kein fehler *)
          end; (* capi_listen_b3 *)

          (* --- CONNECT_B3_CONF --- *)

          capi_connect_b3:begin (* capi_connect_b3 *)
            writeln_screen(0,'CONNECT_B3_CONF...'+capi_error(cp^.b.capi_connect_b3_conf_info));
            if cp^.b.capi_connect_b3_conf_info=0 then begin (* kein fehler *)
              get_plci_index(cp^.b.capi_connect_b3_conf_plci,plci_index);
              if plci_index>0 then begin (* gefunden *)
                ncci_index:=next_free_ncci_index(plci_index);
                if ncci_index=0 then (* eigentlich nie *)
                  writeln_screen(0,'CONNECT_B3_CONF: Kein freier NCCI-Index!')
                else begin (* also: ncci_index(<)>0 *)
                  with plcis^[plci_index].plci_nccis[ncci_index] do begin
                    ncci_word:=cp^.b.capi_connect_b3_conf_ncci;
                    ncci_valid:=true; (* valid *)
                    ncci_status:=2; (* warten auf connect_b3_active_ind *)
                    ncci_x29:=x29_global
                  end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
                end (* ncci_index(<)>0 *)
              end else (* also: plci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_connect_b3_conf_plci,false)+'H nicht gefunden')
            end (* if cp^.b.capi_connect_b3_conf_info=0: kein fehler *)
          end; (* capi_connect_b3 *)

          (* --- DISCONNECT_B3_CONF --- *)

          capi_disconnect_b3:begin (* capi_disconnect_b3 *)
            writeln_screen(0,'DISCONNECT_B3_CONF...'+capi_error(cp^.b.capi_disconnect_b3_conf_info));
            get_ncci_index(cp^.b.capi_disconnect_b3_conf_ncci,plci_index,ncci_index);
            if ncci_index>0 then (* gefunden *)
              plcis^[plci_index].plci_nccis[ncci_index].ncci_status:=22 (* warten auf disconnect_b3_ind *)
            else (* also: ncci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'NCCI=0'+hex_word(cp^.b.capi_disconnect_b3_conf_ncci,false)+'H nicht gefunden')
          end; (* capi_disconnect_b3 *)

          (* --- DATA_B3_CONF --- *)

          capi_data_b3:begin (* capi_data_b3 *)
            with cp^.b do begin
              get_ncci_index(capi_data_b3_conf_ncci,plci_index,ncci_index);
              if ncci_index>0 then begin (* gefunden *)
                if capi_data_b3_conf_info<>0 then (* fehler *)
                  writeln_screen(0,'DATA_B3_CONF...'+capi_error(capi_data_b3_conf_info));
                with plcis^[plci_index].plci_nccis[ncci_index] do
                  ncci_slots:=ncci_slots-[capi_data_b3_conf_number]
              end else (* also: ncci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'NCCI=0'+hex_word(cp^.b.capi_data_b3_conf_ncci,false)+'H nicht gefunden')
            end (* with cp^.b *)
          end (* capi_data_b3 *)

          (* --- SONSTIGES_CONF --- *)

        else (* case cp^.h.command *)
          writeln_screen(0,'Wird nicht untersttzt: '+capi_command(cp^.h.command,false)+'_CONF')
        end (* case cp^.h.command *)
      end; (* verarbeite_message_conf *)

    procedure verarbeite_message_ind(cp:capi_pointer);
      var block:capi_body;
          error:word;
          plci_index:plci_bereich;
          ncci_index:ncci_bereich;
          hs:string[8]; (* nur fr zahlen *)
          ncci_active:boolean;
          regs:dos.registers;

      procedure write_data(cp:pointer;len:word;screen:screen_bereich);
        type big_array=array[0..65534] of byte;
        var pa:^big_array;
            dummy,temp:string;
            lt:byte absolute temp;
            l,w:word;
            p:byte;
            daten,x29:boolean;
            code:integer;
            plci_index:plci_bereich;
            ncci_index:ncci_bereich;

        function tilde_string(s:string;nr:byte):string;
          var temp:string;
              lt:byte absolute temp;
              merke,p,zaehler:byte;
          begin (* tilde_string *)
            temp:='~'+copy(s,1,252)+'~'; (* gesamt max. 254 bytes lang *)
            merke:=0;
            p:=1;
            zaehler:=0;
            while p<=lt do begin
              if temp[p]='~' then begin (* tilde gefunden *)
                if merke=0 then begin (* anfang? *)
                  inc(zaehler);
                  if zaehler=nr then
                    merke:=succ(p)
                end else begin (* also: merke(<)>0: ende *)
                  tilde_string:=copy(temp,merke,p-merke);
                  exit
                end (* merke(<)>0: ende *)
              end; (* if temp[p]='~': tilde gefunden *)
              inc(p)
            end; (* while p<=lt *)
            if merke=0 then (* gar nicht erst angefangen *)
              tilde_string:=''
            else (* also: merke(<)>0: bis zum schlu nehmen *)
              tilde_string:=copy(temp,merke,255)
          end; (* tilde_string *)

        begin (* write_data *)
          l:=len; (* so viele zeichen sind noch auszugeben *)
          w:=0; (* das ist der zeiger auf das big_array, start=0 *)
          pa:=cp;
          with screens[screen] do begin
            plci_index:=screen_plci_index;
            ncci_index:=screen_ncci_index
          end; (* with screens[screen] *)
          x29:=plcis^[plci_index].plci_nccis[ncci_index].ncci_x29;
          if x29 then begin
            case pa^[0] of
              0:begin (* 0: daten *)
                  if odd(pa^[1]) then begin (* q-paket *)
                    if (pa^[2] and 2)=2 then begin (* parameter setzen *)
                      w:=3;
                      while w<len do begin
                        p:=pa^[w];
                        if (p>=1) and (p<=127) then begin (* gltig *)
                          with screens[screen] do
                            plcis^[screen_plci_index].plci_nccis[screen_ncci_index].ncci_par[p]:=pa^[succ(w)]
                        end; (* if (p>=1) and (p<=127): gltig *)
                        w:=succ(succ(w))
                      end; (* while w<len *)
                    end; (* if (pa^[2] and 2)=2: parameter setzen *)
                    daten:=false
                  end else begin (* also: not odd(pa^[1]): kein q-paket *)
                    l:=pred(pred(l)); (* zwei header-bytes wegmachen *)
                    w:=2; (* erste zwei bytes berspringen *)
                    daten:=true
                  end (* not odd(pa^[1]): kein q-paket *)
                end; (* 0: daten *)
              1:begin (* 1: filetransfer *)
                  if pa^[1]=1 then begin (* file-kanal nr. 1 *)
                    with screens[screen] do begin
                      with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] do begin
                        if ncci_down then begin (* luft schon *)
                          if ncci_down_f<>0 then begin (* write file *)
                            with regs do begin
                              ah:=$40; (* write to file *)
                              bx:=ncci_down_f; (* handle *)
                              cx:=pred(pred(len));
                              ds:=seg(pa^[2]);
                              dx:=ofs(pa^[2])
                            end; (* with regs *)
                            msdos(regs)
                          end; (* if ncci_down_f<>0: write file *)
                          ncci_down_i:=ncci_down_i+pred(pred(len));
                          if ncci_down_i>=ncci_down_s then begin (* fertig *)
                            with regs do begin
                              ah:=$3E; (* close a file *)
                              bx:=ncci_down_f (* handle *)
                            end; (* with regs *)
                            msdos(regs);
                            ncci_down:=false
                          end (* if ncci_down_i>=ncci_down_s: fertig *)
                        end else begin (* also: not ncci_down: luft noch nicht *)
                          lt:=pred(pred(len));
                          move(pa^[2],temp[1],lt);
                          for p:=1 to lt do begin
                            if (temp[p] in [#0,' ']) then
                              temp[p]:='~'
                          end; (* for p:=1 to lt *)
                          val(tilde_string(temp,2),ncci_down_s,code);
                          if code<>0 then (* eigentlich nie *)
                            ncci_down_s:=0;
                          lt:=pred(pos('~',temp));
                          ncci_down_fn:=temp;
                          util.timedate(ncci_down_ti,dummy);
                          temp[succ(lt)]:=#0; (* ASCIIZ-string *)
                          with regs do begin
                            ah:=$6C; (* extended open/create *)
                            bx:=$20A1; (* write/deny write/no inherit/fail *)
                            cx:=$0020; (* archive-bit *)
                            dx:=$0012; (* create/overwrite *)
                            ds:=seg(temp[1]);
                            si:=ofs(temp[1])
                          end; (* with regs *)
                          msdos(regs);
                          if odd(regs.flags) then begin (* create error *)
                            str(regs.ax,temp);
                            writeln_screen(screen,'Fehler '+temp+' beim Anlegen des Download-Files!');
                            ncci_down_f:=0 (* handle auf 0 setzen *)
                          end else (* also: not odd(regs.flags) *)
                            ncci_down_f:=regs.ax; (* handle *)
                          ncci_down:=true;
                          ncci_down_i:=0 (* bisher 0 bytes empfangen *)
                        end (* not ncci_down: luft noch nicht *)
                      end (* with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] *)
                    end (* with screens[screen] *)
                  end else begin (* also: pa^[1]<>1: nicht file-kanal nr. 1 *)
                    str(pa^[1],temp);
                    writeln_screen(screen,'Unbekannten File-Kanal ('+temp+') empfangen!')
                  end; (* pa^[1]<>1: nicht file-kanal nr. 1 *)
                  daten:=false
                end (* 1: filetransfer *)
            else (* case pa^[0] *)
              str(pa^[0],temp);
              writeln_screen(screen,'Unbekannten Pakettyp ('+temp+') empfangen!');
              daten:=false
            end (* case pa^[0] *)
          end else (* also: not x29: "einfach so" ausgeben *)
            daten:=true;
          if daten then begin (* es sollen daten ausgegeben werden *)
            while l>0 do begin (* es ist noch etwas auszugeben *)
              if l>255 then (* noch mehr als 255 zeichen zum ausgeben *)
                lt:=255 (* jeden string mit 255 zeichen ausgeben *)
              else (* also: l<=255: nur noch 255 oder weniger zeichen da *)
                lt:=lo(l); (* ausgeben, was noch da ist *)
              move(pa^[w],temp[1],lt);
              write_screen(screen,temp);
              with plcis^[plci_index].plci_nccis[ncci_index] do begin
                if ncci_log then
                  write(ncci_log_f,temp)
              end; (* with plcis^[plci_index].plci_nccis[ncci_index] *)
              w:=w+lt;
              l:=l-lt
            end (* while l>0: es ist noch etwas auszugeben *)
          end (* if daten: es sollen daten ausgegeben werden *)
        end; (* write_data *)

      begin (* verarbeite_message_ind *)
        case cp^.h.command of

          (* --- CONNECT_IND --- *)

          capi_connect:begin (* capi_connect *)
            with cp^.b do begin
              writeln_screen(0,'CONNECT_IND');
              write_screen(0,'Requested service = 0'+hex_byte(capi_connect_ind_requested_service,false));
              write_screen(0,'H / 0'+hex_byte(capi_connect_ind_requested_service_add,false));
              writeln_screen(0,'H / Requested EAZ = '+capi_connect_ind_requested_eaz);
              write_screen(0,'Calling number (');
              case (byte(capi_connect_ind_caller_address[1]) and $70) of
                $00:write_screen(0,'unknown number');
                $10:write_screen(0,'international number');
                $20:write_screen(0,'national number')
              else (* case (byte(connect_ind_caller_address[1]) and $70) *)
                write_screen(0,'illegal number')
              end; (* case (byte(connect_ind_caller_address[1]) and $70) *)
              write_screen(0,'/');
              case (byte(capi_connect_ind_caller_address[1]) and 15) of
                0:write_screen(0,'unknown numbering plan');
                1:write_screen(0,'ISDN numbering plan')
              else (* case (byte(connect_ind_caller_address[1]) and 15) *)
                write_screen(0,'illegal numbering plan')
              end; (* case (byte(connect_ind_caller_address[1]) and 15) *)
              writeln_screen(0,'): '+copy(capi_connect_ind_caller_address,2,255))
            end; (* with cp^.b *)
            plci_index:=next_free_plci_index;
            if plci_index=0 then
              writeln_screen(0,'CONNECT_IND: Kein freier PLCI-Index!')
            else begin (* also: plci_index(<)>0 *)
              with plcis^[plci_index] do begin
                plci_incoming:=cp^.h.number;
                plci_word:=cp^.b.capi_connect_ind_plci;
                plci_valid:=true;
                with block do begin
                  capi_select_b2_protocol_req_plci:=plci_word;
                  capi_select_b2_protocol_req_b2_protocol:=b2;
                  capi_select_b2_protocol_req_dlpd.length:=0
                end (* with block *)
              end; (* with plcis^[plci_index] *)
              error:=capi_send_req(capi_select_b2_protocol,block,4);
              writeln_screen(0,'API_PUT_MESSAGE (SELECT_B2_PROTOCOL)...'+capi_error(error));
              plcis^[plci_index].plci_status:=11 (* warten auf select_b2_protocol_conf *)
            end (* plci_index(<)>0 *)
          end; (* capi_connect *)

          (* --- CONNECT_ACTIVE_IND --- *)

          capi_connect_active:begin (* capi_connect_active *)
            write_screen(0,'CONNECT_ACTIVE_IND');
            with cp^.b do begin
              if length(capi_connect_active_ind_connected_address)>0 then (* steht was drin *)
                write_screen(0,
                             '...(0'+
                             hex_byte(byte(capi_connect_active_ind_connected_address[1]),false)+
                             'H)'+
                             copy(capi_connect_active_ind_connected_address,2,255))
            end; (* with cp^.b *)
            writeln_screen(0,'');
            block.capi_connect_active_resp_plci:=cp^.b.capi_connect_active_ind_plci;
            error:=capi_send_resp(capi_connect_active,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (CONNECT_ACTIVE_RESP)...'+capi_error(error));
            get_plci_index(cp^.b.capi_connect_active_ind_plci,plci_index);
            if plci_index>0 then begin (* gefunden *)
              with plcis^[plci_index] do begin
                case plci_status of
                   2:begin (* 2: abgehender ruf *)
                       with block do begin
                         capi_select_b2_protocol_req_plci:=plci_word;
                         capi_select_b2_protocol_req_b2_protocol:=b2;
                         if b2=8 then begin (* v.110 *)
                           with capi_select_b2_protocol_req_dlpd do begin
                             length:=8;
                             data_length:=130;
                             link_address_a:=3;
                             link_address_b:=1;
                             modulo_mode:=8;
                             window_size:=7;
                             v110_user_rate:=$40; (* 38400/8N1 *)
                             xid:='' (* length=0 *)
                           end (* with capi_select_b2_protocol_req_dlpd *)
                         end else (* also: b2<>8: nicht v.110 *)
                           capi_select_b2_protocol_req_dlpd.length:=0
                       end; (* with block *)
                       error:=capi_send_req(capi_select_b2_protocol,block,4);
                       writeln_screen(0,'API_PUT_MESSAGE (SELECT_B2_PROTOCOL)...'+capi_error(error));
                       plci_status:=3 (* warten auf select_b2_protocol_conf *)
                     end; (* 2: abgehender ruf *)
                  14:begin (* 14: ankommender ruf *)
                       plci_status:=100 (* plci betriebsbereit *)
                     end (* 14: ankommender ruf *)
                else (* case plci_status *)
                  str(plci_status,hs);
                  writeln_screen(0,'Unbekannter PLCI-Status Nr. '+hs+'!')
                end (* case plci_status *)
              end (* with plcis^[plci_index] *)
            end else (* also: plci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_connect_active_ind_plci,false)+'H nicht gefunden')
          end; (* capi_connect_active *)

          (* --- DISCONNECT_IND --- *)

          capi_disconnect:begin (* capi_disconnect *)
            writeln_screen(0,'DISCONNECT_IND...'+capi_error(cp^.b.capi_disconnect_ind_info));
            block.capi_disconnect_resp_plci:=cp^.b.capi_disconnect_ind_plci;
            error:=capi_send_resp(capi_disconnect,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (DISCONNECT_RESP)...'+capi_error(error));
            get_plci_index(cp^.b.capi_disconnect_ind_plci,plci_index);
            if plci_index>0 then begin (* gefunden *)
              with plcis^[plci_index] do begin (* alles auf 0 setzen *)
                plci_status:=0; (* wieder ruhezustand *)
                plci_valid:=false; (* invalid *)
                for ncci_index:=1 to max_ncci do begin (* nccis lschen *)
                  with plci_nccis[ncci_index] do begin
                    if ncci_valid then begin (* war aktiv *)
                      with screens[ncci_screen] do begin (* schirm frei *)
                        screen_plci_index:=0; (* plci_index lschen *)
                        screen_ncci_index:=0 (* ncci_index lschen *)
                      end; (* with screens[ncci_screen]: schirm frei *)
                      if ncci_log then begin
                        close(ncci_log_f);
                        ncci_log:=false;
                        writeln_screen(ncci_screen,'Logfile geschlossen.')
                      end (* if ncci_log *)
                    end; (* if ncci_valid *)
                    ncci_status:=0; (* ruhezustand *)
                    ncci_valid:=false; (* invalid *)
                    ncci_screen:=0 (* kein bildschirm mehr zugeordnet *)
                  end (* with plci_nccis[ncci_index] *)
                end (* for ncci_index:=1 to max_ncci: nccis lschen *)
              end (* with plcis^[plci_index]: alles auf 0 setzen *)
            end else (* also: plci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_disconnect_ind_plci,false)+'H nicht gefunden')
          end; (* capi_disconnect *)

          (* --- INFO_IND --- *)

          capi_info:begin (* capi_info *)
            writeln_screen(0,
                           'INFO_IND...Codeset='+
                           char($30 or (hi(cp^.b.capi_info_ind_info_number) and 7))+
                           '...Infonumber=0'+hex_byte(lo(cp^.b.capi_info_ind_info_number),false)+
                           'H'
                          );
            block.capi_info_resp_plci:=cp^.b.capi_info_ind_plci;
            error:=capi_send_resp(capi_info,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (INFO_RESP)...'+capi_error(error));
            with cp^.b do begin
              case (capi_info_ind_info_number and $07FF) of
                $0602:begin (* $0602: charge *)
                        write_screen(0,'Charge: ');
                        if length(capi_info_ind_info_element)=0 then
                          writeln_screen(0,'Empty.')
                        else (* also: length(...)(<)>0 *)
                          writeln_screen(0,
                                         '(0'+
                                         hex_byte(byte(capi_info_ind_info_element[1]),false)+
                                         'H) '+
                                         copy(capi_info_ind_info_element,2,255))
                      end; (* $0602: charge *)
                $0603:begin (* $0603: date *)
                        writeln_screen(0,'Date: '+capi_info_ind_info_element)
                      end (* $0603: date *)
              else (* case (capi_info_ind_number and $07FF) *)
                writeln_screen(0,'Diese INFO ist nicht implementiert!')
              end (* case (capi_info_ind_number and $07FF) *)
            end (* with cp^.b *)
          end; (* capi_info *)

          (* --- CONNECT_B3_IND --- *)

          capi_connect_b3:begin (* capi_connect_b3 *)
            writeln_screen(0,'CONNECT_B3_IND');
            with block do begin
              capi_connect_b3_resp_ncci:=cp^.b.capi_connect_b3_ind_ncci;
              capi_connect_b3_resp_reject:=0;
              capi_connect_b3_resp_ncpi:=''
            end; (* with block *)
            error:=capi_send_resp(capi_connect_b3,block,4,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (CONNECT_B3_RESP)...'+capi_error(error));
            get_plci_index(cp^.b.capi_connect_b3_ind_plci,plci_index);
            if plci_index>0 then begin (* gefunden *)
              ncci_index:=next_free_ncci_index(plci_index);
              if ncci_index>0 then begin (* war was frei *)
                with plcis^[plci_index].plci_nccis[ncci_index] do begin
                  ncci_word:=cp^.b.capi_connect_b3_ind_ncci;
                  ncci_valid:=true; (* ist ab sofort gltig *)
                  ncci_status:=13 (* warten auf connect_b3_active_ind *)
                end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
              end else (* also: ncci_index(<)>0: war nichts frei *)
                writeln_screen(0,'CONNECT_B3_IND: Kein freier NCCI-Index!')
            end else (* also: plci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'PLCI=0'+hex_word(cp^.b.capi_connect_b3_ind_plci,false)+'H nicht gefunden')
          end; (* capi_connect_b3 *)

          (* --- CONNECT_B3_ACTIVE_IND --- *)

          capi_connect_b3_active:begin (* capi_connect_b3_active *)
            writeln_screen(0,'CONNECT_B3_ACTIVE_IND...NCCI=0'+
                             hex_word(cp^.b.capi_connect_b3_active_ind_ncci,false)
                             +'H');
            block.capi_connect_b3_active_resp_ncci:=cp^.b.capi_connect_b3_active_ind_ncci;
            error:=capi_send_resp(capi_connect_b3_active,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (CONNECT_B3_ACTIVE_RESP)...'+capi_error(error));
            get_ncci_index(cp^.b.capi_connect_b3_active_ind_ncci,plci_index,ncci_index);
            if ncci_index>0 then begin (* gefunden *)
              with plcis^[plci_index].plci_nccis[ncci_index] do begin
                ncci_status:=100; (* ncci betriebsbereit *)
                ncci_slots:=[]; (* derzeit kein slot belegt *)
                ncci_screen:=next_free_screen_index;
                with screens[ncci_screen] do begin
                  screen_plci_index:=plci_index;
                  screen_ncci_index:=ncci_index
                end; (* with screens[ncci_screen] *)
                init_par(ncci_par);
                str(ncci_screen,hs);
                writeln_screen(0,'bergeben an Datenbildschirm Nr. '+hs+'.')
              end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
            end else (* also: ncci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'NCCI=0'+hex_word(cp^.b.capi_connect_b3_active_ind_ncci,false)+'H nicht gefunden')
          end; (* capi_connect_b3_active *)

          (* --- DISCONNECT_B3_IND --- *)

          capi_disconnect_b3:begin (* capi_disconnect_b3 *)
            writeln_screen(0,'DISCONNECT_B3_IND...'+capi_error(cp^.b.capi_disconnect_b3_ind_info));
            block.capi_disconnect_b3_resp_ncci:=cp^.b.capi_disconnect_b3_ind_ncci;
            error:=capi_send_resp(capi_disconnect_b3,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (DISCONNECT_B3_RESP)...'+capi_error(error));
            get_ncci_index(cp^.b.capi_disconnect_b3_ind_ncci,plci_index,ncci_index);
            if ncci_index>0 then begin (* gefunden *)
              with plcis^[plci_index].plci_nccis[ncci_index] do begin
                ncci_status:=0; (* ruhezustand *)
                ncci_valid:=false; (* invalid *)
                with screens[ncci_screen] do begin (* bildschirm ungltig *)
                  screen_plci_index:=0;
                  screen_ncci_index:=0
                end; (* with screens[ncci_screen]: bildschirm ungltig *)
                if ncci_log then begin
                  close(ncci_log_f);
                  ncci_log:=false;
                  writeln_screen(ncci_screen,'Logfile geschlossen.')
                end; (* if ncci_log *)
                ncci_screen:=0 (* kein zugeordneter bildschirm (mehr) *)
              end; (* with plcis^[plci_index].plci_nccis[ncci_index] *)
              ncci_active:=false;
              for ncci_index:=1 to max_ncci do begin
                if plcis^[plci_index].plci_nccis[ncci_index].ncci_status<>0 then
                  ncci_active:=true
              end; (* for ncci_index:=1 to max_ncci *)
              if not ncci_active then begin (* war der letzte: einhngen *)
                with block do begin
                  capi_disconnect_req_plci:=plcis^[plci_index].plci_word;
                  capi_disconnect_req_cause:=0 (* evtl. andere? *)
                end; (* with block *)
                error:=capi_send_req(capi_disconnect,block,3);
                writeln_screen(0,'API_PUT_MESSAGE (DISCONNECT_REQ)...'+capi_error(error));
                plcis^[plci_index].plci_status:=21 (* warten auf disconnect_conf *)
              end (* if not ncci_active: war der letzte: einhngen *)
            end else (* also: ncci_index(<)=0: nicht gefunden *)
              writeln_screen(0,'NCCI=0'+hex_word(cp^.b.capi_disconnect_b3_ind_ncci,false)+'H nicht gefunden')
          end; (* capi_disconnect_b3 *)

          (* --- DATA_B3_IND --- *)

          capi_data_b3:begin (* capi_data_b3 *)
            with cp^.b do begin
              get_ncci_index(capi_data_b3_ind_ncci,plci_index,ncci_index);
              if ncci_index>0 then (* gefunden *)
                write_data(capi_data_b3_ind_data,
                           capi_data_b3_ind_data_length,
                           plcis^[plci_index].plci_nccis[ncci_index].ncci_screen)
              else (* also: ncci_index(<)=0: nicht gefunden *)
                writeln_screen(0,'DATA_B3_IND_NCCI=0'+hex_word(capi_data_b3_ind_ncci,false)+'H nicht gefunden')
            end; (* with cp^.b *)
            with block do begin
              capi_data_b3_resp_ncci:=cp^.b.capi_data_b3_ind_ncci;
              capi_data_b3_resp_number:=cp^.b.capi_data_b3_ind_number
            end; (* with block *)
            error:=capi_send_resp(capi_data_b3,block,3,cp^.h.number);
            if error<>0 then (* bei daten lieber nur bei fehler ausgeben *)
              writeln_screen(0,'API_PUT_MESSAGE (DATA_B3_RESP)...'+capi_error(error))
          end; (* capi_data_b3 *)

          (* --- RESET_B3_IND --- *)

          capi_reset_b3:begin (* capi_reset_b3 *)
            writeln_screen(0,'RESET_B3_IND');
            block.capi_reset_b3_resp_ncci:=cp^.b.capi_reset_b3_ind_ncci;
            error:=capi_send_resp(capi_reset_b3,block,2,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (RESET_B3_RESP)...'+capi_error(error))
          end; (* capi_reset_b3 *)

          (* --- MANUFACTURER_IND --- *)

          capi_manufacturer:begin (* capi_manufacturer *)
            writeln_screen(0,'MANUFACTURER_IND');
            error:=capi_send_resp(capi_manufacturer,block,0,cp^.h.number);
            writeln_screen(0,'API_PUT_MESSAGE (MANUFACTURER_B3_RESP)...'+capi_error(error))
          end (* capi_manufacturer *)

          (* --- SONSTIGES_IND --- *)

        else (* case cp^.h.command *)
          writeln_screen(0,'Wird nicht untersttzt: '+capi_command(cp^.h.command,false)+'_IND')
        end (* case cp^.h.command *)
      end; (* verarbeite_message_ind *)

    begin (* verarbeite_message *)
      case cp^.h.subcommand of
        capi_req :writeln_screen(0,capi_command(cp^.h.command,false)+'_REQ empfangen - Fehler!');
        capi_conf:verarbeite_message_conf(cp);
        capi_ind :verarbeite_message_ind(cp);
        capi_resp:writeln_screen(0,capi_command(cp^.h.command,false)+'_RESP empfamngen - Fehler!')
      else (* case cp^.h.subcommand *)
        writeln_screen(0,capi_command(cp^.h.command,false)+'_'+capi_command(cp^.h.subcommand,true)+' empfangen - Fehler!')
      end (* case cp^.h.subcommand *)
    end; (* verarbeite_message *)

  function all_quiet:boolean;
    var quiet:boolean;
        i:plci_bereich;
    begin (* all_quiet *)
      quiet:=true;
      for i:=1 to max_plci do begin
        with plcis^[i] do begin
          if plci_status<>0 then (* kein ruhezustand *)
            quiet:=false
        end (* with plcis^[i] *)
      end; (* for i:=1 to max_plci *)
      all_quiet:=quiet and (not (connect_pending or listen_pending))
    end; (* all_quiet *)

  procedure close_download_files;
    var plci_index:plci_bereich;
        ncci_index:ncci_bereich;
        regs:dos.registers;
    begin (* close_download_files *)
      for plci_index:=1 to max_plci do begin
        for ncci_index:=1 to max_ncci do begin
          with plcis^[plci_index].plci_nccis[ncci_index] do begin
            if ncci_down then begin (* hier ist noch ein file offen *)
              with regs do begin
                ah:=$3E; (* close a file *)
                bx:=ncci_down_f (* handle *)
              end; (* with regs *)
              msdos(regs);
              ncci_down:=false
            end (* if ncci_down: hier ist noch ein file offen *)
          end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
        end (* for ncci_index:=1 to max_ncci *)
      end (* for plci_index:=1 to max_plci *)
    end; (* close_download_files *)

  function make_connect_req_block(nr:string;var block:capi_body):word;
    var ln:byte absolute nr;
    begin (* make_connect_req_block *)
      with block do begin
        capi_connect_req_controller:=0;               (* immer 1. contr.  *)
        capi_connect_req_b_channel:=$83;              (* b-kanal beliebig *)
        capi_connect_req_info_mask:=$3F;              (* alle bits setzen *)
        capi_connect_req_outgoing_service:=7;         (* daten            *)
        capi_connect_req_outgoing_service_add:=0;     (* kein add.si.     *)
        capi_connect_req_source_eaz:='0';             (* anruf von 0      *)
        capi_connect_req_destination_address:=#$81+nr (* unknown/isdn     *)
      end; (* with block *)
      make_connect_req_block:=11+ln
    end; (* make_connect_req_block *)

  function sendstring(nr:screen_bereich;s:string):word;
    var ls:byte absolute s;
        b:data_bereich;
        block:capi_body;
        error:word;
    begin (* sendstring *)
      if nr=0 then (* am statusbildschirm kann nichts gesendet werden *)
        sendstring:=$FFFE (* fehler-kennzeichnung *)
      else begin (* also: nr(<)>0: datenbildschirm aktiv *)
        if nr>max_screen then (* zu groe nummer *)
          sendstring:=$FFFD (* fehler-kennzeichnung *)
        else begin (* also: nr<=max_screen *)
          with screens[nr] do begin
            with plcis^[screen_plci_index] do begin
              if (plci_status=100) and plci_valid then begin (* bereit *)
                with plci_nccis[screen_ncci_index] do begin
                  if (ncci_status=100) and ncci_valid then begin (* bereit *)
                    ncci_data1:=ncci_data1+copy(s,1,255-length(ncci_data1));
                    sendstring:=0
                  end else (* also: (ncci_status<>100) or (not ncci_valid) *)
                    sendstring:=$FFFB (* fehler-kennzeichnung *)
                end (* with plci_nccis[screen_ncci_index] *)
              end else (* also: (plci_status<>100) or (not plci_valid) *)
                sendstring:=$FFFC (* fehler-kennzeichnung *)
            end (* with plcis^[screen_plci_index] *)
          end (* with screens[nr] *)
        end (* nr<=max_screen *)
      end (* nr(<)>0: datenbildschirm aktiv *)
    end; (* sendstring *)

  procedure send_buffers;
    var b:data_bereich;
        block:capi_body;
        error:word;
        plci_index:plci_bereich;
        ncci_index:ncci_bereich;
        l,p:byte;
        temp:string;
        lt:byte absolute temp;
    begin (* send_buffers *)
      for plci_index:=1 to max_plci do begin
        for ncci_index:=1 to max_ncci do begin
          with plcis^[plci_index].plci_nccis[ncci_index] do begin
            l:=length(ncci_data1);
            if l>0 then begin (* etwas zum senden da *)
              b:=0;
              while (b in ncci_slots) and (b<7) do
                inc(b);
              if not (b in ncci_slots) then begin (* freien slot gefunden *)
                if l<=128 then (* pat in ein paket *)
                  lt:=l
                else (* also: l>128: nur die ersten 128 bytes nehmen *)
                  lt:=128;
                move(ncci_data1[1],temp[1],lt);
                ncci_data2[b]:=temp;
                delete(ncci_data1,1,lt);
                if ncci_x29 and (ncci_par[2]<>0) then begin (* evtl. echo *)
                  if (ncci_par[13] and 4)=4 then begin (* LF nach CR *)
                    p:=1;
                    while p<=lt do begin
                      if temp[p]=^M then
                        insert(^J,temp,succ(p));
                      inc(p)
                    end (* while p<=lt *)
                  end; (* if (ncci_par[13] and 4)=4: LF nach CR *)
                  write_screen(ncci_screen,temp)
                end; (* if ncci_x29 and (ncci_par[2]<>0): evtl. echo *)
                with block do begin
                  capi_data_b3_req_ncci:=ncci_word;
                  capi_data_b3_req_data_length:=length(ncci_data2[b]);
                  capi_data_b3_req_data:=addr(ncci_data2[b][1]);
                  capi_data_b3_req_number:=b;
                  capi_data_b3_req_flags:=0
                end; (* with block *)
                error:=capi_send_req(capi_data_b3,block,11);
                if error=0 then (* senden ok *)
                  ncci_slots:=ncci_slots+[b] (* slot belegen *)
                else (* also: error<>0: senden fehler *)
                  writeln('SEND_BUFFERS: '+capi_error(error))
              end (* if not (b in ncci_slots): freien slot gefunden *)
            end (* if l>0: etwas zum senden da *)
          end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
        end (* for ncci_index:=1 to max_ncci *)
      end (* for plci_index:=1 to max_plci *)
    end; (* send_buffers *)

  procedure hangup(nr:screen_bereich);
    var block:capi_body;
        error:word;
        disconnect,disconnect_b3:boolean;
        hs:string[8]; (* nur fr zahlen *)
    begin (* hangup *)
      if nr=0 then (* statusbildschirm *)
        writeln_screen(0,'Der Status-Bildschirm kann nicht getrennt werden!')
      else begin (* also: nr(<)>0 *)
        if nr>max_screen then (* eigentlich nie *)
          writeln_screen(0,'Zu groe Bildschirm-Nummer!')
        else begin (* also: nr<=max_screen *)
          with screens[nr] do begin
            if (screen_plci_index=0) or (screen_ncci_index=0) then
              writeln_screen(0,'Auf diesem Kanal besteht keine Verbindung!')
            else begin (* also: (...plci...(<)>0) and (...ncci...(<)>0) *)
              disconnect:=false;
              disconnect_b3:=false;
              with plcis^[screen_plci_index] do begin
                case plci_status of
                    0:writeln_screen(0,'Der Anschlu befindet sich bereits im Ruhezustand!');
                    1:writeln_screen(0,'Der Connect-Request wurde noch nicht besttigt!');
                    2,
                   14:disconnect:=true;
                    3,
                   11:writeln_screen(0,'Der Select-B2-Protocol-Request wurde noch nicht besttigt!');
                    4,
                   12:writeln_screen(0,'Der Select-B3-Protocol-Request wurde noch nicht besttigt!');
                   13:writeln_screen(0,'Der Listen-B3-Request wurde noch nicht besttigt!');
                   21,
                   22:writeln_screen(0,'Der Disconnect-Request wurde bereits gesendet!');
                   31:writeln_screen(0,'Der Listen-Request wurde noch nicht besttigt!');
                  100:begin (* plci betriebsbereit *)
                        with plci_nccis[screen_ncci_index] do begin
                          case ncci_status of
                              0,
                             12:disconnect:=true; (* kein ncci vorhanden *)
                              1:writeln_screen(0,'Der Connect-B3-Request wurde noch nicht besttigt!');
                             11:writeln_screen(0,'Der Listen-B3-Request wurde noch nicht besttigt!');
                              2,
                             13,
                            100:disconnect_b3:=true; (* ncci vorhanden *)
                             21,
                             22:writeln_screen(0,'Der B3-Disconnect wurde bereits gesendet!')
                          else (* case ncci_status *)
                            str(ncci_status,hs);
                            writeln_screen(0,'Der Anschlu befindet sich im undefinierten NCCI-Zustand Nr. '+hs+'!')
                          end; (* case ncci_status *)
                          if disconnect_b3 then begin
                            with block do begin
                              capi_disconnect_b3_req_ncci:=ncci_word;
                              capi_disconnect_b3_req_ncpi:='' (* lnge=0 *)
                            end; (* with block *)
                            error:=capi_send_req(capi_disconnect_b3,block,3);
                            writeln_screen(0,'API_PUT_MESSAGE (DISCONNECT_B3_REQ)...'+capi_error(error));
                            if error=0 then (* put ok *)
                              ncci_status:=21 (* warten auf disconnect_b3_conf *)
                          end (* if disconnect_b3 *)
                        end (* with plci_nccis[screen_ncci_index] *)
                      end (* plci betriebsbereit *)
                else (* case plci_status *)
                  str(plci_status,hs);
                  writeln_screen(0,'Der Anschlu befindet sich im undefinierten PLCI-Zustand Nr. '+hs+'!')
                end; (* case plci_status *)
                if disconnect then begin
                  with block do begin
                    capi_disconnect_req_plci:=plci_word;
                    capi_disconnect_req_cause:=0
                  end; (* with block *)
                  error:=capi_send_req(capi_disconnect,block,3);
                  writeln_screen(0,'API_PUT_MESSAGE (DISCONNECT_REQ)...'+capi_error(error));
                  if error=0 then (* put ging gut *)
                    plci_status:=21 (* warten auf disconnect_conf *)
                end (* if disconnect *)
              end (* with plcis^[screen_plci_index] *)
            end (* (...plci...(<)>0) and (...ncci...(<)>0) *)
          end (* with screens[nr] *)
        end (* nr<=max_screen *)
      end (* nr(<)>0 *)
    end; (* hangup *)

  procedure upload_check;
    var plci_index:plci_bereich;
        ncci_index:ncci_bereich;
        error:word;
        temp:string;
        lt:byte absolute temp;
        p,soll:byte;
        regs:dos.registers;
    begin (* upload_check *)
      for plci_index:=1 to max_plci do begin
        for ncci_index:=1 to max_ncci do begin
          with plcis^[plci_index].plci_nccis[ncci_index] do begin
            if ncci_up then begin
              soll:=255-length(ncci_data1);
              if soll>0 then begin (* noch platz *)
                with regs do begin
                  ah:=$3F; (* read *)
                  bx:=ncci_up_f; (* handle *)
                  cx:=word(soll); (* so viele bytes maximal *)
                  ds:=seg(temp[1]);
                  dx:=ofs(temp[1])
                end; (* with regs *)
                msdos(regs);
                if odd(regs.flags) then
                  writeln('UPLOAD_CHECK: Lesefehler!')
                else begin (* also: not odd(regs.flags): kein lesefehler *)
                  lt:=regs.al; (* so viele bytes gelesen *)
                  if lt<soll then begin (* war eof *)
                    with regs do begin
                      ah:=$3E; (* close *)
                      bx:=ncci_up_f (* handle *)
                    end; (* with regs *)
                    msdos(regs);
                    write(^G);
                    ncci_up:=false
                  end; (* if lt<soll *)
                  p:=pos(^J,temp);
                  while p>0 do begin (* linefeeds rausmachen *)
                    delete(temp,p,1);
                    p:=pos(^J,temp)
                  end; (* while p>0: linefeeds rausmachen *)
                  ncci_data1:=ncci_data1+temp
                end (* if ncci_slots<>[0..max_data]: geht *)
              end (* if soll>0: noch platz *)
            end (* if ncci_up *)
          end (* with plcis^[plci_index].plci_nccis[ncci_index] *)
        end (* for ncci_index:=1 to max_ncci *)
      end (* for plci_index:=1 to max_plci *)
    end; (* upload_check *)

  begin (* s0term *)
    assign(input,'');
    reset(input);
    assign(output,'');
    rewrite(output);

    (* --- VERSIONS-TEST --- *)

    if dos_version<4 then begin
      writeln('Dieses Programm luft erst ab MSDOS 4.0 aufwrts!');
      halt(3)
    end; (* if dos_version<4 *)

    (* --- BILDSCHIRM-INITIALISIERUNGEN --- *)

    if (mem[$40:$10] and $30)=$30 then
      screen:=ptr($B000,0)
    else (* also: (mem[$40:$10] and $30)<>$30 *)
      screen:=ptr($B800,0);
    clrscr;
    for cb:=0 to max_screen do begin
      with screens[cb] do begin
        screen_video:=screen^;
        screen_row:=0;
        screen_column:=0;
        screen_plci_index:=0;
        screen_ncci_index:=0
      end (* with screens[cb] *)
    end; (* for cb:=0 to max_screen *)
    active:=0; (* schirm nr. 0 ist aktiv *)

    (* --- STARTMELDUNG AUSGEBEN --- *)

    writeln_screen(0,'=== START ===');

    (* --- ERST TESTEN, OB DAS CAPI INSTALLIERT IST --- *)

    if not capi_is_installed then begin (* ist nicht installiert *)
      writeln_screen(0,'CAPI not installed!');
      halt(1)
    end; (* if not capi_is_installed: ist nicht installiert *)

    (* --- HERSTELLER, VERSIONS- UND SERIENNUMMER ANZEIGEN --- *)

    writeln_screen(0,'Manufacturer: '+capi_get_manufacturer);
    writeln_screen(0,'Versions-No.: '+capi_get_version);
    writeln_screen(0,'Serialnumber: '+capi_get_serial_number);
    writeln_screen(0,'V.110 wird mit B2=8 und B3=4 eingestellt.');
    writeln_screen(0,'Erst ab CAPI Version 1.4i mglich!');

    (* --- ANWENDUNG ANMELDEN --- *)

    error:=capi_register;
    if error<>0 then begin (* register fehler *)
      writeln_screen(0,'API_REGISTER...'+capi_error(error));
      halt(2)
    end; (* if error<>0: register fehler *)

    (* --- RESTLICHE INITIALISIERUNGEN --- *)

    ende:=false;
    new(plcis);
    fillchar(plcis^,sizeof(plcis^),0); (* alle eintrge ungltig machen *)
    clr:=false;
    connect_pending:=false;
    listen_pending:=false;

    (* --- MAIN EVENT LOOP --- *)

    repeat

      (* --- EVTL. ANGEKOMMENE MESSAGE VERARBEITEN --- *)

      error:=capi_get_message(cp);
      case error of
        $0000:verarbeite_message(cp);
        $1006:begin (* message queue empty *) end
      else (* case error *)
        writeln_screen(0,'API_GET_MESSAGE...'+capi_error(error))
      end; (* case error *)

      (* --- EVTL. GEDRCKTE TASTE VERARBEITEN --- *)

      if keypressed then begin (* taste gedrckt *)
        c:=readkey;
        if c=#0 then begin (* sondertaste *)
          c:=readkey;
          case c of
             #46:begin (* alt-c: clr umschalten *)
                   clr:=not clr
                 end; (* alt-c: clr umschalten *)
             #32:begin (* alt-d: dial *)
                   if active=0 then begin (* schirm nr. 0 aktiv *)
                     if connect_pending then
                       writeln_screen(0,'Es ist noch ein unbesttigtes CONNECT unterwegs.')
                     else begin (* also: not connect_pending *)
                       if next_free_plci_index=0 then
                         writeln_screen(0,'Es sind keine freien PLCI-Slots mehr vorhanden.')
                       else begin (* also: next_free_plci_index(<)>0 *)
                         write_screen(0,'Nummer? ');
                         readln(temp);
                         if lt>0 then begin (* irgendwas eingegeben *)
                           abfragen:=(temp[1]='/');
                           if abfragen then
                             delete(temp,1,1);
                           len:=make_connect_req_block(temp,block);
                           if abfragen then begin
                             write('B2-Protokoll (1=Standard, 3=Transparent, RETURN=1)? ');
                             readln(temp);
                             if lt=0 then
                               b2:=1
                             else begin (* also: lt(<)>0 *)
                               val(temp,i,code);
                               if code=0 then
                                 b2:=lo(i)
                               else (* also: code(<)>0 *)
                                 b2:=1
                             end; (* lt(<)>0 *)
                             write('B3-Protokoll (1=Standard, 4=Transparent, RETURN=1)? ');
                             readln(temp);
                             if lt=0 then
                               b3:=1
                             else begin (* also: lt(<)>0 *)
                               val(temp,i,code);
                               if code=0 then
                                 b3:=lo(i)
                               else (* also: code(<)>0 *)
                                 b3:=1
                             end; (* lt(<)>0 *)
                             with block do begin
                               write('Service Indikator (1=Telefon, 7=Daten, RETURN=7)? ');
                               readln(temp);
                               if lt=0 then
                                 capi_connect_req_outgoing_service:=7
                               else begin (* also: lt(<)>0 *)
                                 val(temp,i,code);
                                 if code=0 then
                                   capi_connect_req_outgoing_service:=lo(i)
                                 else (* also: code(<)>0 *)
                                   capi_connect_req_outgoing_service:=7
                               end; (* lt(<)>0 *)
                               write('Additional Service Indikator (1=Telefon, 0=Daten, $9F=Mailbox, RETURN=$9F)? ');
                               readln(temp);
                               if lt=0 then
                                 capi_connect_req_outgoing_service_add:=$9F
                               else begin (* also: lt(<)>0 *)
                                 val(temp,i,code);
                                 if code=0 then
                                   capi_connect_req_outgoing_service_add:=lo(i)
                                 else (* also: code(<)>0 *)
                                   capi_connect_req_outgoing_service_add:=$9F
                               end (* lt(<)>0 *)
                             end (* with block *)
                           end else begin (* also: not abfragen *)
                             b2:=1;
                             b3:=1;
                             with block do begin
                               capi_connect_req_outgoing_service:=7;
                               capi_connect_req_outgoing_service_add:=$9F
                             end (* with block *)
                           end; (* not abfragen *)
                           x29_global:=(block.capi_connect_req_outgoing_service_add=$9F);
                           error:=capi_send_req(capi_connect,block,len);
                           writeln_screen(0,'API_PUT_MESSAGE (CONNECT_REQ)...'+capi_error(error));
                           connect_pending:=(error=0)
                         end (* if lt>0: irgendwas eingegeben *)
                       end (* next_free_plci_index(<)>0 *)
                     end (* not connect_pending *)
                   end else begin (* also: active(<)>0: datenschirm aktiv *)
                     with screens[active] do begin
                       with plcis^[screen_plci_index] do begin
                         if plci_status=100 then begin
                           with plci_nccis[screen_ncci_index] do begin
                             if ncci_status=100 then begin
                               with block do begin
                                 capi_connect_b3_req_plci:=plci_word;
                                 capi_connect_b3_req_ncpi:='' (* lnge 0 *)
                               end; (* with block *)
                               error:=capi_send_req(capi_connect_b3,block,3);
                               writeln_screen(0,'API_PUT_MESSAGE (CONNECT_B3_REQ)...'+capi_error(error))
                             end else (* also: ncci_status<>100 *)
                               write(^G)
                           end (* with plci_nccis[screen_ncci_index] *)
                         end else (* also: plci_status<>100 *)
                           write(^G)
                       end (* with plcis^[screen_plci_index] *)
                     end (* with screens[active] *)
                   end (* active(<)>0: datenschirm aktiv *)
                 end; (* alt-d: dial *)
             #35:begin (* alt-h: hangup *)
                   hangup(active)
                 end; (* alt-h: hangup *)
             #38:begin (* alt-l: listen *)
                   if active=0 then begin (* schirm nr. 0 aktiv *)
                     if listen_pending then
                       writeln_screen(0,'Es ist noch ein unbesttigtes LISTEN unterwegs.')
                     else begin (* also: not listen_pending *)
                       with block do begin
                         capi_listen_req_controller:=0;          (* nur 1.ctr *)
                         capi_listen_req_info_mask:=$3F;         (* alle bits *)
                         capi_listen_req_serviced_eaz_mask:=$3FF;(* alle eazs *)
                         capi_listen_req_serviced_si_mask:=$0080 (* nur daten *)
                       end; (* with block *)
                       error:=capi_send_req(capi_listen,block,9);
                       writeln_screen(0,'API_PUT_MESSAGE (LISTEN_REQ)...'+capi_error(error));
                       listen_pending:=(error=0)
                     end (* not listen_pending *)
                   end else (* also: active(<)>0: datenschirm aktiv *)
                     write(^G)
                 end; (* alt-l: listen *)
             #31:begin (* alt-s: status *)
                   if active=0 then
                     writeln_screen(0,'Auf dem Status-Bildschirm luft nie ein Hintergrund-Download!')
                   else begin (* also: active(<)>0 *)
                     with screens[active] do begin
                       with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] do begin
                         if ncci_down then begin
                           writeln_screen(active,'');
                           str(ncci_down_s,temp);
                           writeln_screen(active,'Es luft gerade der Hintergrund-Download von '+
                                          ncci_down_fn+
                                          ' ('+temp+' Bytes).');
                           str(ncci_down_i,temp);
                           write_screen(active,'bertragen wurden bereits '+temp+' Bytes (');
                           str(100.0*ncci_down_i/ncci_down_s:0:0,temp);
                           write_screen(active,temp+'%) in ');
                           util.timedate(time,date);
                           time:=util.zeitdifferenz(ncci_down_ti,time);
                           writeln_screen(active,time+'.');
                           str(1.0*ncci_down_i/util.time2secs(time):0:0,temp);
                           write_screen(active,'Das sind '+temp+' CPS. ');
                           writeln_screen(active,'Die verbleibende Zeit betrgt '+
                                          util.secs2time(
                                                          round (
                                                                  (
                                                                    (
                                                                      1.0
                                                                      *
                                                                      ncci_down_s
                                                                      /
                                                                      ncci_down_i
                                                                    )
                                                                    -
                                                                    1.0
                                                                  )
                                                                  *
                                                                  util.time2secs(time)
                                                                )
                                                        )+'.'
                                         )
                         end else (* also: not ncci_down *)
                           writeln('Auf diesem Bildschirm luft gerade kein Hintergrund-Download!')
                       end (* with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] *)
                     end (* with screens[active] *)
                   end (* active(<)>0 *)
                 end; (* alt-s: status *)
             #45:begin (* alt-x: exit *)
                   if all_quiet then (* ruhezustand auf allen kanlen *)
                     ende:=true
                   else (* also: not all_quiet: irgendwas ist los *)
                     writeln('Der Anschlu befindet sich nicht im Ruhezustand!')
                 end; (* alt-x: exit *)
             #73:begin (* page-up: upload *)
                   with screens[active] do begin
                     with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] do begin
                       if ncci_up then
                         writeln('Es luft bereits ein Upload.')
                       else begin (* also: not ncci_up *)
                         if ncci_status=100 then begin (* ncci aktiv *)
                           write('Dateiname? ');
                           readln(temp);
                           if lt>0 then begin (* etwas eingegeben *)
                             temp[succ(lt)]:=#0;
                             with regs do begin
                               ah:=$6C; (* open *)
                               bx:=$2040; (* readonly, denynone, noharderr *)
                               cx:=$0020; (* attr. eigentlich unwichtig *)
                               dx:=$0001; (* fehler wenn nicht gefunden *)
                               ds:=seg(temp[1]);
                               si:=ofs(temp[1])
                             end; (* with regs *)
                             msdos(regs);
                             if odd(regs.flags) then
                               writeln('Datei ',temp,' nicht vorhanden!')
                             else begin (* also: not odd(regs.flags) *)
                               ncci_up_f:=regs.ax;
                               ncci_up:=true
                             end (* not odd(regs.flags) *)
                           end (* if lt>0: etwas eingegeben *)
                         end else (* also: ncci_status<>100: kein zustand fr datenbertragung *)
                           writeln('Dieser Kanal ist nicht im Datenbertragungszustand!')
                       end (* not ncci_up *)
                     end (* with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] *)
                   end (* with screens[active] *)
                 end; (* page-up: upload *)
             #81:begin (* page-down *)
                   with screens[active] do begin
                     with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] do begin
                       if ncci_log then begin
                         close(ncci_log_f);
                         ncci_log:=false;
                         writeln_screen(active,'Logfile geschlossen.')
                       end else begin (* also: not ncci_log *)
                         if ncci_status=100 then begin (* ncci aktiv *)
                           write_screen(active,'Dateiname? ');
                           readln(temp);
                           if lt>0 then begin (* etwas eingegeben *)
                             assign(ncci_log_f,temp);
                             (*$I-*)
                             rewrite(ncci_log_f);
                             (*$I+*)
                             if ioresult=0 then begin
                               ncci_log:=true;
                               writeln_screen(active,'Logfile geffnet.')
                             end else (* also: ioresult(<)>0 *)
                               writeln_screen(active,'Logfile kann nicht geffnet werden.')
                           end (* if lt>0: etwas eingegeben *)
                         end else (* also: ncci_status<>100: kein zustand fr datenbertragung *)
                           writeln('Dieser Kanal ist nicht im Datenbertragungszustand!')
                       end (* not ncci_log *)
                     end (* with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] *)
                   end (* with screens[active] *)
                 end; (* page-down *)
            #120
             ..
            #129:begin (* alt-0 bis alt-9 *)
                   cb:=byte(c)-119;
                   if cb=10 then
                     cb:=0;
                   if cb<=max_screen then (* nummer ok *)
                     active_screen(cb)
                   else (* also: cb>max_screen: nummer ungltig *)
                     write(^G)
                 end (* alt-0 bis alt-9 *)
          else (* case c: undefinierte sondertaste *)
            write(^G)
          end (* case c: undefinierte sondertaste *)
        end else begin (* also: c(<)>#0: normales zeichen *)
          with screens[active] do begin
            with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] do begin
              if (c=#27) and ncci_up then begin (* upload abbrechen *)
                with regs do begin
                  ah:=$3E; (* close *)
                  bx:=ncci_up_f
                end; (* with regs *)
                msdos(regs);
                ncci_up:=false;
                writeln('Upload abgebrochen.')
              end else begin (* also: nicht upload abbrechen *)
                error:=sendstring(active,c);
                if error<>0 then
                  writeln_screen(active,'SENDSTRING...'+capi_error(error))
              end (* nicht upload abbrechen *)
            end (* with plcis^[screen_plci_index].plci_nccis[screen_ncci_index] *)
          end (* with screens[active] *)
        end (* c(<)>#0: normales zeichen *)
      end; (* if keypressed: taste gedrckt *)

      (* --- EVTL. UPLOADS VERARBEITEN --- *)

      upload_check;

      (* --- EVTL. SENDEPUFFER SENDEN --- *)

      send_buffers

      (* --- ENDE DER HAUPTSCHLEIFE --- *)

    until ende;

    (* --- EVTL. NOCH OFFENE DOWNLOAD-FILES SCHLIESSEN --- *)

    close_download_files;

    (* --- ANWENDUNG ABMELDEN --- *)

    error:=capi_release;
    if error<>0 then (* release fehler *)
      writeln_screen(0,'API_RELEASE...'+capi_error(error));

    (* --- ENDE --- *)

    dispose(plcis)
  end. (* s0term *)
